<ion-content>
    <ion-toolbar>
        <ion-buttons slot="start">
            <ion-menu-button></ion-menu-button>
        </ion-buttons>
        <ion-item>
            <ion-label>{{ 'Requests >> Joining' | translate }}</ion-label>
        </ion-item>
    </ion-toolbar>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>
    <div *ngIf="!this.cache?.isLoading">

        <ion-list *ngFor="let joiningRequest of this.cache?.objects; index as i">
            <ion-card>
                <ion-item>
                    <ion-avatar slot="start">
                        <img [src]="joiningRequest.user.profilePicture.content">
                    </ion-avatar>
                    <ion-label>{{joiningRequest.user.name}}</ion-label>
                </ion-item>
                <div>
                    <ion-grid>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="person"></ion-icon>
                                {{joiningRequest.user.type}}
                            </ion-label>
                        </ion-row>
                        <ion-row *ngIf="joiningRequest.user.type === 'Resident'">
                            <ion-label>
                                <ion-icon name="person"></ion-icon>
                                {{joiningRequest.residentType}}
                            </ion-label>
                        </ion-row>
                        <ion-row *ngIf="joiningRequest.user.type === 'Resident'">
                            <ion-label>
                                <ion-icon name="home"></ion-icon>
                                {{joiningRequest.requestedFacility.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-chip color="success" *ngIf="joiningRequest.approvalStatus === 'Approved'">
                                <ion-icon name="checkmark"></ion-icon>
                                <ion-label>{{ 'Approved' | translate }}</ion-label>
                            </ion-chip>
                            <ion-chip color="danger" *ngIf="joiningRequest.approvalStatus === 'Rejected'">
                                <ion-icon name="close"></ion-icon>
                                <ion-label>{{ 'Rejected' | translate }}</ion-label>
                            </ion-chip>
                            <ion-chip color="primary" *ngIf="joiningRequest.approvalStatus === 'Pending'">
                                <ion-icon name="stopwatch"></ion-icon>
                                <ion-label>{{ 'Pending' | translate }}</ion-label>
                            </ion-chip>
                        </ion-row>
                        <ion-row>
                            <ion-buttons *ngIf="joiningRequest.approvalStatus === 'Pending'">
                                <ion-button (click)="approveJoiningRequest(joiningRequest)">{{ 'Approve' | translate }}
                                </ion-button>
                                <ion-button (click)="rejectJoiningRequest(joiningRequest)">{{ 'Reject' | translate }}
                                </ion-button>
                            </ion-buttons>
                        </ion-row>
                    </ion-grid>
                </div>
            </ion-card>
        </ion-list>
        <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
            <ion-item>
                <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
            </ion-item>
        </ion-card>
        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content loadingSpinner="bubbles" loadingText="Loading ...">
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>

    <ion-card *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card-header>
            <ion-card-title>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-title>
            <ion-card-subtitle>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-subtitle>
        </ion-card-header>

        <ion-card-content>
            <ion-item>
                <ion-label>
                    <ion-skeleton-text animated></ion-skeleton-text>
                </ion-label>
            </ion-item>
            <div>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
            </div>
        </ion-card-content>
    </ion-card>
</ion-content>